//---------------------------------------------------------------------------

#include <vcl.h>
#include <math.h>
#pragma hdrstop

#include "sterowanie.h"
#include "Main.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm2 *Form2;
float MrotX[4][4];
float MrotY[4][4];
float MrotZ[4][4];
float MScal[4][4];

void Multi(float m[4][4], float m1[4][4], float m2[4][4])
{
 int i,j,k,l;
 for (i=0; i<4; i++)
  for (j=0; j<4; j++)
  {
   m[i][j]=0;
   for (k=0; k<4; k++)
    m[i][j]+=m1[i][k]*m2[k][j];
  }
}

void CalculateMatrix()
{
 float Mtmp1[4][4];
 float Mtmp2[4][4];

 if (Form2->RadioGroup1->ItemIndex==1)
 {
  Multi(Mtmp1,MrotX,MScal);
  Multi(Mtmp2,MrotY,Mtmp1);
  Multi(M,MrotZ,Mtmp2);
 }
 else
 {
  Multi(Mtmp1,MrotY,MrotZ);
  Multi(Mtmp2,MrotX,Mtmp1);
  Multi(M,MScal,Mtmp2);
 }
 TransformVerteces();
 Form1->Invalidate();
}
//---------------------------------------------------------------------------
__fastcall TForm2::TForm2(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm2::Button1Click(TObject *Sender)
{
 Form1->Invalidate();
}
//---------------------------------------------------------------------------
void __fastcall TForm2::SRotZChange(TObject *Sender)
{
 float ang;
 ang=SRotZ->Position*M_PI/180;
 for (int i=0; i<4; i++)
  for (int j=0; j<4; j++)
   MrotZ[i][j]=0;
 MrotZ[0][0] = MrotZ[1][1] = cos(ang);
 MrotZ[1][0] = sin(ang) ;
 MrotZ[0][1] = -MrotZ[1][0] ;
 MrotZ[2][2] = 1 ;
 MrotZ[3][3] = 1 ;
 CalculateMatrix();
}
//---------------------------------------------------------------------------
void __fastcall TForm2::SRotXChange(TObject *Sender)
{
 float ang;
 ang=SRotX->Position*M_PI/180;
 for (int i=0; i<4; i++)
  for (int j=0; j<4; j++)
   MrotX[i][j]=0;
 MrotX[2][2] = MrotX[1][1] = cos(ang);
 MrotX[2][1] = sin(ang) ;
 MrotX[1][2] = -MrotX[2][1] ;
 MrotX[0][0] = 1 ;
 MrotX[3][3] = 1 ;
 CalculateMatrix();
}
//---------------------------------------------------------------------------
void __fastcall TForm2::SRotYChange(TObject *Sender)
{
 float ang;
 ang=SRotY->Position*M_PI/180;
 for (int i=0; i<4; i++)
  for (int j=0; j<4; j++)
   MrotY[i][j]=0;
 MrotY[0][0] = MrotY[2][2] = cos(ang);
 MrotY[0][2] = sin(ang) ;
 MrotY[2][0] = -MrotY[0][2] ;
 MrotY[1][1] = 1 ;
 MrotY[3][3] = 1 ;
 CalculateMatrix();
}
//---------------------------------------------------------------------------
void __fastcall TForm2::FormCreate(TObject *Sender)
{
 int i,j;
 for (i=0; i<4; i++)
 {
  for (j=0; j<4; j++)
  {
   MrotX[i][j]=0;
   MrotY[i][j]=0;
   MrotZ[i][j]=0;
   MScal[i][j]=0;
  }
  MrotX[i][i]=1;
  MrotY[i][i]=1;
  MrotZ[i][i]=1;
  MScal[i][i]=1;
 }
}
//---------------------------------------------------------------------------
void __fastcall TForm2::SScalXChange(TObject *Sender)
{
 MScal[0][0]=SScalX->Position/100.0;
 CalculateMatrix();
}
//---------------------------------------------------------------------------
void __fastcall TForm2::SScalYChange(TObject *Sender)
{
 MScal[1][1]=SScalY->Position/100.0;
 CalculateMatrix();
}
//---------------------------------------------------------------------------
void __fastcall TForm2::SScalZChange(TObject *Sender)
{
 MScal[2][2]=SScalZ->Position/100.0;
 CalculateMatrix();          
}
//---------------------------------------------------------------------------
void __fastcall TForm2::CheckBox1Click(TObject *Sender)
{
 Form1->Invalidate();        
}
//---------------------------------------------------------------------------
void __fastcall TForm2::PerspektywaClick(TObject *Sender)
{
 Form1->Invalidate();
}
//---------------------------------------------------------------------------

void __fastcall TForm2::OddalenieChange(TObject *Sender)
{
 Form1->Invalidate();
}
//---------------------------------------------------------------------------

void __fastcall TForm2::ZoomChange(TObject *Sender)
{
 Form1->Invalidate();        
}
//---------------------------------------------------------------------------

